#include<iostream>

using namespace std;


int main(){
	
	
	long long int i, k,fakt,brojac,tacke,j,brojac_vrsta;
	int a[10000];
	
	cin>>k;
	
	fakt=6652800;
	brojac=0;
	tacke=0;
	for(i=11;i>=3;i--){
		
		while(k>=fakt){
			k=k-fakt;
			
			a[brojac]=fakt;
			brojac++;
			tacke=tacke+fakt;
			
			
		}
		
		fakt=fakt/i;
	}
	for(i=0;i<brojac;i++){
		if(a[i]==1){
			a[i]=3;
			tacke=tacke+2;
			
		}
	}
	
	cout<<tacke;
	cout<<endl;
	brojac_vrsta=0;
	for(i=0;i<brojac;i++){
		
		for(j=brojac_vrsta;j<=a[i]+brojac_vrsta-1;j++){
			
			cout<<i<<' '<<j;
			cout<<endl;
			
			
		}
		
		brojac_vrsta=2*brojac_vrsta+a[i]+1;
	}
	
	
	
		
		

	
}